﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HW09CPC
{
    /// Erstellt eine Grayscale Colormap
    class ColormapGray : IColormapGenerator
    {
        private int m_steps;
        private float[] m_map = null;

        /// Erstellt eine neue Colormap mit der angegebenen Anzahl an Stützpunkten
        /// <param name="steps">Größe des Arrays</param>
        public ColormapGray(int steps)
        {
            if (steps < 2)
                throw new ArgumentException("Muss mind. zwei Werte haben");
            m_steps = steps;
        }

        /// Generiert das gewünschte Array beim ersten Aufruf, liefert das zwischengespeicherte Array bei jedem Folgeaufruf zurück.
        /// <returns>Array mit der im Konstruktor spezifizierten Länte</returns>
        public float[] getRgbaMap() 
        {
            if (m_map != null)
                return m_map;

            m_map = new float[4 * m_steps];

            for (int i = 0; i < m_steps; i++)
            {
                int cpos = 4 * i;
                float gval = (float)(((double)i) / (m_steps - 1));
                m_map[cpos + 0] = gval; /* r */
                m_map[cpos + 1] = gval; /* g */
                m_map[cpos + 2] = gval; /* b */
                m_map[cpos + 3] = 1; /* a */
            }

            return m_map;
        }
    }
}
