﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using OpenTK.Graphics.OpenGL;

namespace HW09CPC
{
    /// Stellt die Kapselungen eines GL-Shaders dar.
    class GLShader
    {
        private string mFilename;
        private int mHandle;
        private ShaderType mType;
        private string mShaderData;    
        
        /// Konstruktor
        /// <param name="_type">der Shader Typ</param>
        /// <param name="_filename">der Dateiname</param>
        public GLShader(ShaderType _type, string _filename)
        {
	        mType = _type;
	        mFilename = _filename;
	        mHandle = -1;

            mShaderData = Utility.fileToStr(mFilename);

	        compile();
        }

        /// Löscht den Shader
        public void delete() {
	        GL.DeleteShader(mHandle);	    
        }
        
        /// Liefert den Handle zurück
        /// <returns>der Handle</returns>
        public int getHandle()
        {
	        return mHandle;
        }

        private void compile()
        {
	        mHandle = GL.CreateShader(mType);

	        GL.ShaderSource(mHandle, mShaderData);

	        GL.CompileShader(mHandle);

	        int compiled;
            GL.GetShader(mHandle, ShaderParameter.CompileStatus, out compiled);

	        if(compiled == 0)
            {
                Console.Out.WriteLine("Shader compilation failed: " + mFilename);
                Console.Out.WriteLine("Error log:");
                Console.Out.Write(GL.GetShaderInfoLog(mHandle));

		        throw new Exception("GLShader - compilation failed");
	        }
        }

        private void printData()
        {
            Console.Out.Write(mShaderData);
        }
    }
}
