﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using OpenTK.Graphics.OpenGL;

namespace HW09CPC
{
    /// Stellt die Basis-Klasse der RGBA-Texturen Kapselungen dar.
    public abstract class GLTextureRgba : GLTexture 
    {
	    protected bool mIsSrgb;	

        protected GLTextureRgba(string _name, uint _width, uint _height, TextureUnit _textureUnit, bool _generateMipmap, bool _srgb, float[] _data)
            : base(_name, _width, _height, _textureUnit, _generateMipmap, _data)
	    {
	        initMembers(_srgb);
        }

        private void initMembers(bool _srgb)
        {
	        if(_srgb)
	        {
		        mIsSrgb = true;
                mInternalFormat = PixelInternalFormat.Srgb8Alpha8;
	        }
	        else
	        {
		        mIsSrgb = false;
                mInternalFormat = PixelInternalFormat.Rgba32f;
	        }

	        setLinear();
        }

        protected bool isSrgb()
        {
	        return mIsSrgb;
        }

        /// Läd die Textur in den Grafikspeicher und das angegebene Mipmap-Level
        /// <param name="_level">das gewünschte Mipmap-Level</param>
        override public abstract void uploadTexture(int _level = 0);
    }
}
