﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using OpenTK.Graphics.OpenGL;

namespace HW09CPC
{
    /// Stellt die Kapselungen einer 1D RGBA-Textur dar.
    class GLTextureRgba1D : GLTextureRgba
    {
        /// Konstruktor
        /// <param name="_name">der Name der Textur</param>
        /// <param name="_width">die Breite</param>
        /// <param name="_textureUnit">die Textur-Einheit</param>
        /// <param name="_generateMipmap">true: Mipmaps werden generiert</param>
        /// <param name="_srgb">true: die Textur wird in SRGB angelegt</param>
        /// <param name="_generateTexture">true: die Textur wird sofort geladen</param>
        /// <param name="_data">das Array der Pixel-Daten</param>
        public GLTextureRgba1D(string _name, uint _width, TextureUnit _textureUnit, bool _generateMipmap, bool _srgb, bool _generateTexture, float[] _data)
	        : base(_name, _width, 0, _textureUnit, _generateMipmap, _srgb, _data)
        {
            if (mWidth != _data.Length/4)
                throw new Exception("GLTextureRgba1D: data/dimentions mismatch");

	        initMembers();

	        if(_generateTexture)
		        loadTexture();
        }

        private void initMembers()
        {
	        mTarget = TextureTarget.Texture1D;
        }

        /// Läd die Textur in den Grafikspeicher und das angegebene Mipmap-Level
        /// <param name="_level">das gewünschte Mipmap-Level</param>
        override public void uploadTexture(int _level = 0)
        {
            GL.TexImage1D(mTarget, 0, mInternalFormat, (int)mWidth, 0, mFormat, mType, mData);
	        if(mIsMipmapped)
		        generateMipmap();
        }
    }
}
