#version 150
#extension GL_EXT_gpu_shader4 : enable

uniform int axisCount;
uniform vec4 axisColor;

layout(points) in;
layout(line_strip, max_vertices = 2) out;

out vec4 vertexColor;

vec4 convertToFlatNDC(vec2 _pos)
{
	return vec4(_pos * 2.0 - vec2(1.0), 0.0, 1.0);
}

void main()
{
	// calculate line vertices	
	float xStep = 1.0 / float(axisCount - 1);
	float x = gl_PrimitiveIDIn * xStep;
	
	// calculate y values from point-line dualism	
	vec2 pos1 = vec2(x, 0);
	vec2 pos2 = vec2(x, 1);

	// generate line primitive
	gl_Position = convertToFlatNDC(pos1);
	vertexColor = axisColor; 
	EmitVertex();
		
	gl_Position = convertToFlatNDC(pos2);
	vertexColor = axisColor; 
	EmitVertex();

	EndPrimitive();
}