#version 130

uniform sampler2D tex;
uniform sampler1D colormap;

uniform sampler2D maxTex;
uniform float maxLevel;

in vec2 texCoord2d;

out vec4 outColor1;
 
void main(void)
{
	vec4 max = texture2DLod(maxTex, vec2(0.5, 0.5), maxLevel);

	vec4 texCol = texture2D(tex, texCoord2d);
	vec4 mappedCol = texture1D(colormap, texCol.x/max.x)*min(texCol.a,1);

	outColor1 = mappedCol;	
}