#version 130

uniform sampler2D readTex;
uniform float readLevel;

uniform float halfTexelSize;

in vec2 texCoord2d;

out vec4 outColor1;

vec4 getMax(vec2 p1, vec2 p2)
{
	vec4 s1 = texture2DLod(readTex, p1, readLevel);
	vec4 s2 = texture2DLod(readTex, p2, readLevel);

	if(s1.x > s2.x)
		return s1;
	else
		return s2;
}

void main(void)
{
	vec4 m1 = getMax(
		vec2(texCoord2d.x + halfTexelSize, texCoord2d.y + halfTexelSize),
		vec2(texCoord2d.x + halfTexelSize, texCoord2d.y - halfTexelSize)
		);

	vec4 m2 = getMax(
		vec2(texCoord2d.x - halfTexelSize, texCoord2d.y + halfTexelSize),
		vec2(texCoord2d.x - halfTexelSize, texCoord2d.y - halfTexelSize)
		);

	if(m1.x > m2.x)
		outColor1 = m1;
	else
		outColor1 = m2;

	//outColor1 = vec4(texCoord2d, 0.0, 1.0);
}