#version 130

uniform int axisCount;
uniform int currentAxisIndex;

uniform float y0Min;
uniform float y0Max;
uniform float y1Min;
uniform float y1Max;

in float yValue;

void main(void)
{
	float xStep = 1.0 / float(axisCount - 1);

	vec2 pos;
	if(mod(gl_VertexID, 2) == 0)
	{
		float x = currentAxisIndex * xStep;
		pos = vec2(x, (yValue-y0Min)/(y0Max-y0Min));
	}
	else
	{
		float x = (currentAxisIndex + 1) * xStep;
		pos = vec2(x, (yValue-y1Min)/(y1Max-y1Min));
	}

	gl_Position = vec4(pos*2.0 - vec2(1.0), 0.0, 1.0);
}